<template>
  <q-header class="header">
    <q-btn
      class="header__contacts-toggle"
      color="black"
      dense
      flat
      round
      @click="$emit('handleContacts', isContacts = !isContacts)"
    >
      <iconBase
        class="header__contacts-toggle__icon"
        icon-name="contacts"
      >
        <contacts />
      </iconBase>
    </q-btn>

    <router-link tag="a" to="/">
      <NameChat />
    </router-link>

    <div class="header__right-side">
      <SelectLanguage />
      <ContactItem :user="user" onlyAvatar />
    </div>
  </q-header>
</template>

<script lang="ts">
import { defineComponent, ref, computed, watch } from '@vue/composition-api'
import NameChat from 'components/NameChat.vue'
import ContactItem from './ContactItem.vue'
import SelectLanguage from './SelectLanguage.vue'
import contacts from 'components/icons/contacts.vue'

export default defineComponent({
  name: 'Header',
  components: {
    NameChat,
    ContactItem,
    SelectLanguage,
    contacts
  },

  props: {
    isContactsProp: {
      type: Boolean,
      default: true
    }
  },

  setup (props, ctx) {
    const isContacts = ref(props.isContactsProp)
    const user = computed(() => ctx.root.$store.state.main.user)

    watch(() => props.isContactsProp, (newValue) => {
      isContacts.value = newValue
    })

    return {
      isContacts,
      user
    }
  }
})
</script>

<style lang="scss" scoped>
@import '../css/variables';

.header {
  background: #fff;
  height: 72px;
  padding: 10px;
  display: flex;
  box-shadow: 0 0 25px -5px rgba(0,0,0,.4);
  justify-content: space-between;
  overflow: hidden;

  &>*:not(:first-child) {
    margin-left: 10px;
  }

  &__contacts-toggle {
    z-index: 2000;

    &__icon {
      stroke: $brandColorGray;
      stroke-width: 18px;
      width: 40px;
      height: 40px;
    }
  }

  &__right-side {
    display: flex;
    align-items: center;

    &>*:first-child {
      margin-right: 10px;
    }
  }
}
</style>
